'use strict';

exports.__esModule = true;
exports.resetProxies = exports.createProxyForType = exports.updateProxyById = exports.getProxyByType = exports.getIdByType = undefined;

var _reactStandIn = require('react-stand-in');

var _reactStandIn2 = _interopRequireDefault(_reactStandIn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let proxiesByID;
let idsByType;

let elementCount = 0;

const generateTypeId = () => `auto-${elementCount++}`;

const getIdByType = exports.getIdByType = type => idsByType.get(type);

const getProxyByType = exports.getProxyByType = type => proxiesByID[getIdByType(type)];

const updateProxyById = exports.updateProxyById = (id, type) => {
  // Remember the ID.
  idsByType.set(type, id);

  if (!proxiesByID[id]) {
    proxiesByID[id] = (0, _reactStandIn2.default)(type, id);
  } else {
    proxiesByID[id].update(type);
  }
  return proxiesByID[id];
};

const createProxyForType = exports.createProxyForType = type => getProxyByType(type) || updateProxyById(generateTypeId(), type);

const resetProxies = exports.resetProxies = () => {
  proxiesByID = {};
  idsByType = new WeakMap();
};